﻿@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;


@Html.DevExpress().GridView(
        setting =>
        {
            setting.Name = "PartialPlanData";
            setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
            //setting.Width = Unit.Percentage(100);
            //setting.Width = Unit.Pixel(1205);
            setting.Width = System.Web.UI.WebControls.Unit.Percentage(100);
            setting.KeyFieldName = "PlantCode";

            setting.CallbackRouteValues = new { Controller = "Plant", Action = "PartialPlantDatas" };
            
            setting.SettingsEditing.UpdateRowRouteValues = new { Controller = "Plant", Action = "PartialPlantDatas" };
            
            setting.SettingsEditing.Mode = GridViewEditingMode.EditFormAndDisplayRow;
            //setting.CommandColumn.Visible = true;
            //setting.CommandColumn.EditButton.Visible = true;
            //setting.CommandColumn.Width = Unit.Pixel(100);

            //setting.SettingsPager.PageSize = 20;
            setting.SettingsPager.PageSize = 10;
            setting.SettingsPager.PageSizeItemSettings.Visible = true;
            setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
            setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
            setting.SettingsPager.Position = PagerPosition.Bottom;
            setting.SettingsPager.FirstPageButton.Visible = true;
            setting.SettingsPager.LastPageButton.Visible = true;
            setting.Settings.ShowHorizontalScrollBar = true;
            //setting.Settings.ShowVerticalScrollBar = true;
            setting.Settings.ShowColumnHeaders = true;
            setting.Settings.ShowFilterRow = true;
            setting.Settings.ShowFilterRowMenu = true;

            //setting.Columns.Add("Check", "Status", MVCxGridViewColumnType.CheckBox).Width = Unit.Pixel(50);
            //var firstcc = new MVCxGridViewCommandColumn();
            ////firstcc.ShowSelectCheckbox = true;
            //setting.Columns.Add(firstcc);
            //firstcc.VisibleIndex = 0;
            //firstcc.Visible = true;
            //firstcc.Caption = "Action";
            //firstcc.Width = 65;
            ////firstcc.VisibleIndex = 0;
            //firstcc.EditButton.Visible = true;
            ///**firstcc.SetHeaderTemplateContent(c =>
            //{
            //    Html.DevExpress().CheckBox(settingCheckBox =>
            //    {
            //        settingCheckBox.Name = "firstcommancolumn";
            //        settingCheckBox.Text = "Action";
            //        settingCheckBox.Properties.ClientSideEvents.CheckedChanged =
            //        string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}",
            //        setting.Name);
            //        settingCheckBox.Checked = c.Grid.VisibleRowCount == c.Grid.Selection.Count;
            //    }).Render();
            //});*/

            //// kodingan sampe disini, still not fixed is how to updated the current header row column become checkbox for selected all, after that updated all
            //// form become like this for add new column checkbox type, with adding it finish before imam asked it, and check for the mulki job, and try to solved
            //// one or two before..

            //var secondCC = new MVCxGridViewCommandColumn();
            //setting.Columns.Add(secondCC);
            //secondCC.ShowSelectCheckbox = true;
            //setting.Settings.ShowColumnHeaders = true;
            //secondCC.VisibleIndex = 1;
            //secondCC.Visible = true;
            //secondCC.Caption = "Choose";
            //secondCC.Width = 75;
            ////secondCC.VisibleIndex = 0;
            //secondCC.ClearFilterButton.Visible = true;
            //secondCC.SetHeaderTemplateContent(
            //    c =>
            //    {
            //        Html.DevExpress().CheckBox(
            //                chckBox =>
            //                {
            //                    chckBox.Name = "chckBox";
            //                    chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ PartialPlanData.SelectAllRowsOnPage(chckBox.GetChecked());}";
            //                }
            //            ).Render();
            //    });
            
            // pertama kita set untuk checkboxnya dulu
            setting.CommandColumn.Visible = true;
            //setting.CommandColumn.Width = 65;
            //setting.CommandColumn.Width = System.Web.UI.WebControls.Unit.Percentage(50);
            setting.CommandColumn.ClearFilterButton.Visible = true;
            setting.CommandColumn.Visible = true;
            setting.Settings.VerticalScrollableHeight = 400;
            setting.Settings.ShowColumnHeaders = true;
            setting.CommandColumn.Visible = true;
            setting.CommandColumn.VisibleIndex = 0;
            setting.CommandColumn.ShowSelectCheckbox = true;
            setting.CommandColumn.SetHeaderTemplateContent(
                c =>
                {
                    if (c.Column.VisibleIndex == 0)
                    {
                        Html.DevExpress().CheckBox(
                            chckBox =>
                            {
                                chckBox.Name = "chckBox";
                                chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ PartialPlanData.SelectAllRowsOnPage(chckBox.GetChecked());}";
                            }
                        ).Render();
                    }
                }
                );
            
            // setelah itu baru kita set untuk fungsi button editnya
            var firstcc = new MVCxGridViewCommandColumn();
            firstcc.VisibleIndex = 1;
            firstcc.Visible = true;
            firstcc.Caption = "Action";
            //firstcc.Width = 65;
            //firstcc.Width = setting.CommandColumn.Width = System.Web.UI.WebControls.Unit.Percentage(50);
            firstcc.EditButton.Visible = true;
            setting.Columns.Add(firstcc);
            
            setting.Columns.Add("PlantCode", "Plant Code", MVCxGridViewColumnType.TextBox).Width = Unit.Pixel(100);
            setting.Columns["PlantCode"].CellStyle.HorizontalAlign = HorizontalAlign.Center;
            setting.Columns.Add("PlantName", "Plant Name", MVCxGridViewColumnType.TextBox);
            setting.Columns["PlantName"].CellStyle.HorizontalAlign = HorizontalAlign.Center;
            
            setting.SetEditFormTemplateContent(c =>
            {
                ViewContext.Writer.Write(
                    "<div class=\"edit_form\">" +
                    "<div class=\"line\">"
                    );
                Html.DevExpress().Label(
                    edit =>
                    {
                        edit.ControlStyle.CssClass = "label";
                        edit.Text = "Plant Code";
                    }).Render();
                Html.DevExpress().TextBox(
                    edit =>
                    {
                        edit.Name = "PlantCodeTextBox";
                        edit.Width = setting.CommandColumn.Width = System.Web.UI.WebControls.Unit.Percentage(50);
                    }).Render();

                ViewContext.Writer.Write(
                   "<div class=\"edit_form\">" +
                   "<div class=\"line\">"
                   );
                Html.DevExpress().Label(
                    edit =>
                    {
                        edit.ControlStyle.CssClass = "label";
                        edit.Text = "Plant Name";
                    }).Render();
                Html.DevExpress().TextBox(
                    edit =>
                    {
                        edit.Name = "PlantNameTextBox";
                    }).Render();
                
                ViewContext.Writer.Write(
                    "<div class=\"edit_form\">" +
                    "<div class=\"line\">"
                    );
                Html.DevExpress().Label(
                edit =>
                {
                    edit.ControlStyle.CssClass = "label";
                    edit.Text = "";
                }).Render();
            Html.DevExpress().Button(
                btnSettings =>
                {
                    btnSettings.Name = "btnUpdate";
                    btnSettings.ControlStyle.CssClass = "button";
                    btnSettings.Text = "Update";
                }).Render();
            Html.DevExpress().Button(
                btnSettings =>
                {
                    btnSettings.Name = "btnCancel";
                    btnSettings.ControlStyle.CssClass = "button";
                    btnSettings.Text = "Cancel";
                }).Render();         
            ViewContext.Writer.Write(
                "</div>" +
                "</div>");
            });


        }).Bind(Model.GetModel<Portal.Models.Plant.PlantModel>().PlantsData).GetHtml()